<?php

include_once('../includes/system.php');

class Export extends Module
{
  var $Id;
  var $AnoNe = array('Ne', 'Ano');
  var $WhereLang;
  var $WhereUsers;
  var $SelectedUsers;
  var $UserNames;
  var $User;
  var $ClientVersion;
  var $OrderByUserList;
  
  function Init()
  {
    $this->TempDir = $this->Config['Web']['TempFolder'].'Export/'.$this->Id.'/';
    if(!file_exists($this->TempDir)) mkdir($this->TempDir, 0777, true);
  }
  
  function LoadFilters()
  {  
    $DbResult = $this->Database->query('SELECT * FROM `Export` WHERE Id='.$this->Id);
    $this->Export = $DbResult->fetch_assoc();

    // Filter selected languages
    $this->WhereLang = '';
    $DbResult = $this->Database->query('SELECT * FROM `ExportLanguage` WHERE Export='.$this->Id.' ORDER BY Sequence');
    while($Language = $DbResult->fetch_assoc())
      $this->WhereLang .= ' OR (Language = '.$Language['Language'].')'; 
    if($this->WhereLang == '') $WhereLang = 1; 
      else $this->WhereLang = '('.substr($this->WhereLang, 4).')';

    // Filter selected users
    $this->SelectedUsers = '';  
    $DbResult = $this->Database->query('SELECT * FROM `ExportUser` WHERE Export='.$this->Id.' ORDER BY Sequence');
    while($User = $DbResult->fetch_assoc())
      $this->SelectedUsers .= ','.$User['User'];
    $this->SelectedUsers = substr($this->SelectedUsers, 1);
   
    if($this->SelectedUsers == '') $Where = 0;
      else $Where = 'ID IN ('.$this->SelectedUsers.')';
  
    $this->UserNames = '';
    $DbResult = $this->Database->query('SELECT user FROM `user` WHERE '.$Where);
    while($DbRow = $DbResult->fetch_assoc())
      $this->UserNames .= ','.$DbRow['user'];
    $this->UserNames = substr($this->UserNames, 1);    
   
    if($this->SelectedUsers == '')
    {
      $this->WhereUsers = 1;
      $this->OrderByUserList = '';
    } else
    {
      $this->WhereUsers = '(User IN ('.$this->SelectedUsers.'))';
      $this->OrderByUserList = ' ORDER BY FIELD(User, '.$this->SelectedUsers.')';
    }
    
    if(isset($_SESSION) and ($_SESSION['UserID'] != ''))
    {
      $DbResult = $this->Database->query('SELECT user FROM `user` WHERE ID='.$_SESSION['UserID']);
      $this->User = $DbResult->fetch_assoc();
    } else $this->User = array('user' => 'Neznámý');

    $DbResult = $this->Database->query('SELECT * FROM `wow_client_version` WHERE `Id`='.$this->Export['ClientVersion']);
    $this->ClientVersion = $DbResult->fetch_assoc();    
  }

  function ExportToMangosSQL()
  {
    global $TranslationTree, $LanguageList;
  
    $this->LoadFilters();
    
    $Buffer = 
      "-- Generováno projektem wowpreklad.zdechov.net\n". 
      "-- ===========================================\n".
      "--\n".
      "-- Web projektu: ".$this->Config['Web']['BaseURL']."\n".
      "-- Datum exportu: ".date("j.n.Y  H:i:s")."\n".
      "-- Znaková sada: ".$this->Config['Database']['Charset']." / ".$this->Config['Web']['Charset']."\n".
      "-- Diakritika: ".$this->AnoNe[$this->Export['WithDiacritic']]."\n".
      "-- Vygeneroval uživatel: ".$this->User['user']."\n".
      "-- Vzato od uživatelů: ".$this->UserNames."\n".
      "-- Generované tabulky: ";
    
    $DbResult = $this->Database->query('SELECT `group`.* FROM `ExportGroup` JOIN `group` ON `group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
       $Buffer .= $Group['MangosTable'].', ';
    }
    $Buffer .= "\n\n";  

    $DbResult = $this->Database->query('SELECT `group`.* FROM `ExportGroup` JOIN `group` ON `group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
      if($Group['MangosTable'] != '')
      {
        $Query = 'SELECT * FROM (SELECT * FROM '.$Group['TablePrefix'].' WHERE (Complete = 1) AND VersionStart <= '.$this->ClientVersion['BuildNumber'].' AND VersionEnd >= '.$this->ClientVersion['BuildNumber'].' AND '.$this->WhereLang.' AND '.$this->WhereUsers.' ORDER BY FIELD(User, '.$this->SelectedUsers.')) AS T GROUP BY T.entry';  
        //echo($Query);
        $Buffer .= "\n\n-- ".$Group['Name']."\n\n";
        $DbResult2 = $this->Database->query($Query);
        while($Line = $DbResult2->fetch_array()) 
        {
          $Values = '';
          foreach($TranslationTree[$Group['Id']]['Items'] as $GroupItem)
          {
            if($GroupItem['MangosColumn'] == '') $GroupItem['MangosColumn'] = $GroupItem['Column'];
            $Values .= ', `'.$GroupItem['MangosColumn'].'`="'.addslashes($Line[$GroupItem['Column']]).'"';
          }
          $Values = substr($Values, 2);
          $Buffer .= 'UPDATE `'.$Group['MangosTable'].'` SET '.$Values.' WHERE `'.$Group['MangosTableIndex'].'` = '.$Line['entry'].';'."\n"; 
        }     
      }
    }
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    return($Buffer);
  }
  
  function ExportToAoWoWSQL() 
  {
    global $Config, $TranslationTree, $AoWoWconf, $LanguageList;
  
    require_once('../aowow/configs/config.php');
  
    $Buffer = $this->ExportToMangosSQL();
 
    $this->LoadFilters();

    // Data to aowow

    $Database2 = new mysqli($this->Config['Database']['Host'], $this->Config['Database']['User'], $this->Config['Database']['Password'], $this->Config['Database']['Database']);
    $Database2->query('SET NAMES '.$this->Config['Database']['Charset']);
    $Database2->select_db($AoWoWconf['mangos']['db']);    
    $AoWoWTables = array('aowow_resistances' => 'Id', 'aowow_spelldispeltype' => 'Id', 'aowow_skill' => 'skillID');
    foreach($AoWoWTables as $AoWoWTable => $IndexColum) 
    {
      $Buffer .= '--'.$AoWoWTable.', ';
      $Buffer .= "\n\n";  
      $Query = 'SELECT name,'.$IndexColum.' FROM '.$AoWoWTable;
      $DbResult = $Database2->query($Query);
      while($Line = $DbResult->fetch_assoc()) 
      {
        $Ori_text = $Line['name'];
        $DbResult2 = $Datbase2->query('SELECT text as en,
        (SELECT text FROM '.$Config['Database']['Database'].'.global_strings as tabletran
         WHERE tableen.entry = tabletran.entry AND (Complete = 1) AND '.$WhereLang.'
          AND '.$WhereUsers.' ORDER BY FIELD(User, '.$SelectedUsers.') LIMIT 1) as tran
         FROM '.$Config['Database']['Database'].'.global_strings as tableen WHERE
          text = "'.addslashes($Ori_text).'" LIMIT 1');
        $Tran = $DbResult2->fetch_assoc();
        //echo ($Line['name'].'='.$Tran['tran']);
        if($Tran['tran'] == '') 
        {
          $DbResult2 = $Database2->query('SELECT OptionText as en,
          (SELECT OptionText FROM '.$this->Config['Database']['Database'].'.npc_option as tabletran
           WHERE tableen.entry = tabletran.entry AND (Complete = 1) AND '.$this->WhereLang.'
            AND '.$this->WhereUsers.' ORDER BY FIELD(User, '.$this->SelectedUsers.') LIMIT 1) as tran
          FROM '.$this->Config['Database']['Database'].'.npc_option as tableen WHERE
            OptionText = "'.addslashes($Ori_text).'" LIMIT 1');
          $Tran = $DbResult2->fetch_assoc();
        }
        
        if($Tran['tran'] <> '')
          $Buffer .= 'UPDATE `'.$AoWoWTable.'` SET name = "'.addslashes($Tran['tran']).'" WHERE '.$IndexColum.' = '.$Line[$IndexColum].' ;'."\n";
      }
      $Buffer .= "\n\n";  
    }
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    return($Buffer);
  }  
 
  
  function ExportToXML()
  {
    global $TranslationTree, $LanguageList;
  
    $this->LoadFilters($this->Id);

    $Buffer = '<?xml version="1.0" encoding="utf-8"?>'."\n".
    "<document>\n".
    "  <meta>\n".
    "    <projecturl>".$this->Config['Web']['BaseURL']."</projecturl>\n".
    "    <time>".date('r')."</time>\n".
    "    <diacritics mode=".'"'.$this->Export['WithDiacritic'].'"'." />\n".
    "    <author>".$this->User['user']."</author>\n".
    "    <contributors>\n";
    foreach(explode(',', $this->UserNames) as $UserName)
      $Buffer .= "      <user>".$UserName."</user>\n";
    $Buffer .= 
    "    </contributors>\n".
    "  </meta>\n".
    "  <translation>\n";

    $DbResult = $this->Database->query('SELECT `group`.* FROM `ExportGroup` JOIN `group` ON `group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id);
    while($Group = $DbResult->fetch_assoc())
    {
      if($Group['MangosTable'] == '')
      {
        $Group['MangosTable'] = $Group['TablePrefix'];
        $Group['MangosTableIndex'] = 'entry';
      }
      $Query = 'SELECT *,(SELECT user FROM user WHERE user.ID=T.User) as UserName FROM (SELECT * FROM '.$Group['TablePrefix'].' WHERE (Complete = 1) AND VersionStart <= '.$this->ClientVersion['BuildNumber'].' AND VersionEnd >= '.$this->ClientVersion['BuildNumber'].' AND '.$this->WhereLang.' AND '.$this->WhereUsers.' ORDER BY FIELD(User, '.$this->SelectedUsers.')) AS T GROUP BY T.entry'; 
      //echo($Query);
      $Buffer .= '    <group id="'.$Group['Id'].'" name="'.$Group['TablePrefix'].'">'."\n";
      $DbResult2 = $this->Database->query($Query);
      while($Line = $DbResult2->fetch_assoc()) 
      {
        $Buffer .= '      <item id="'.$Line['entry'].'" user="'.$Line['UserName'].'">'."\n";
        $Values = '';
        foreach($TranslationTree[$Group['Id']]['Items'] as $GroupItem)
        {
          if($GroupItem['MangosColumn'] == '') $GroupItem['MangosColumn'] = $GroupItem['Column'];
          if($Line[$GroupItem['Column']] != '')
          $Buffer .= '        <text index="'.$GroupItem['Id'].'" name="'.$GroupItem['Column'].'">'.addslashes($Line[$GroupItem['Column']]).'</text>'."\n";
        }
        $Buffer .= "      </item>\n";
      }    
      $Buffer .= "    </group>\n";
    }
    if($this->Export['WithDiacritic'] != 1) $Buffer = utf2ascii($Buffer);
    $Buffer .= "  </translation>\n".
  "</document>";
    return($Buffer);
  }      

  function ExportToDBC()
  {
    global $TranslationTree, $LanguageList;
  
    $this->LoadFilters();

    $DbResult = $this->Database->query('SELECT `group`.* FROM `ExportGroup` JOIN `group` ON `group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id.' AND `group`.`DBCFileName` != ""');
    while($Group = $DbResult->fetch_assoc())
    {
      echo($Group['Name'].'... ');
      $DBCFile = new DBCFile();
      $DBCFile->OpenFile('../source/'.$this->ClientVersion['Version'].'/dbc/'.$Group['DBCFileName'].'.dbc', GetDBCColumns($Setting['Version'], $Group['DBCFileName']));
      $DBCFile2 = new DBCFile();
      $DBCFile2->CreateFile($this->TempDir.$Group['DBCFileName'].'.dbc', GetDBCColumns($this->ClientVersion['Version'], $Group['DBCFileName']));
      $Count = $DBCFile->GetRecordCount();
      //if($Group['DBCFileName'] == 'Spell') $Count = 1000;
      $Line = $DBCFile->GetLine(0);
      $DBCFile2->SetRecordCount($Count);   
      for($I = 0; $I < $Count; $I++)
      {
        $Line = $DBCFile->GetLine($I);
        $Query = 'SELECT * FROM (SELECT * FROM '.$Group['TablePrefix'].' WHERE (Complete = 1) AND '.$this->WhereLang.' AND '.$this->WhereUsers.' AND (entry='.$Line[0].')  AND VersionStart <= '.$this->ClientVersion['BuildNumber'].' AND VersionEnd >= '.$this->ClientVersion['BuildNumber'].' ORDER BY FIELD(User, '.$this->SelectedUsers.')) AS T GROUP BY T.entry';       
        $DbResult2 = $this->Database->query($Query);
        if($DbResult2->num_rows > 0)
        {
          $DbRow = $DbResult2->fetch_assoc();
          //  if($Setting['Diacritics'] != 1) $Buffer = utf2ascii($Buffer);

          foreach($TranslationTree[$Group['Id']]['Items'] as $GroupItem)
            if(GetDBCColumnIndex($this->ClientVersion['Version'], $Group['DBCFileName'], $GroupItem['Column']) != '')
          $Line[GetDBCColumnIndex($this->ClientVersion['Version'], $Group['DBCFileName'],$GroupItem['Column'])] = $DbRow[$GroupItem['Column']];
          //print_r($Line);
        }
        $DBCFile2->SetLine($I, $Line);
        echo('.');
      }
      $DBCFile2->Commit();
      echo('Hotovo <br />');
    }
  }

  function ExportToLua()
  {
    global $TranslationTree, $LanguageList;
  
    $this->LoadFilters();

    $DbResult = $this->Database->query('SELECT `group`.* FROM `ExportGroup` JOIN `group` ON `group`.`Id` = `ExportGroup`.`Group` WHERE `ExportGroup`.`Export`='.$this->Id.' AND `group`.`LuaFileName` != ""');
    while($Group = $DbResult->fetch_assoc())
    {
      echo($Group['Name'].'... ');
      $File = new FileStream();
      $File->OpenFile('../source/'.$this->ClientVersion['Version'].'/lua/'.$Group['LuaFileName'].'.lua');
      $File2 = new FileStream();
      $File2->CreateFile($this->TempDir.''.$Group['LuaFileName'].'.lua');
 
      while(!$File->EOF())
      {
        $Line = $File->ReadLine();
        if(strpos($Line, '=') !== false)
        {
          $LineParts = explode(';', $Line);
          $LineParts2 = explode('=', $LineParts[0]);
          $Value['ShortCut'] = trim($LineParts2[0]);
          $Value['Text'] = substr(trim($LineParts2[1]), 1, -1);
          $Value['Comment'] = addslashes(substr(trim($LineParts[1]), 3));

          $Query = 'SELECT * FROM (SELECT * FROM '.$Group['TablePrefix'].' WHERE (Complete = 1) AND '.$this->WhereLang.' AND '.$this->WhereUsers.' AND (ShortCut="'.$Value['ShortCut'].'") AND VersionStart <= '.$this->ClientVersion['BuildNumber'].' AND VersionEnd >= '.$this->ClientVersion['BuildNumber'].' ORDER BY FIELD(User, '.$this->SelectedUsers.')) AS T GROUP BY T.entry';
          //echo($Query);
          $DbResult2 = $this->Database->query($Query);
          if($DbResult2->num_rows > 0)
          {
            $DbRow = $DbResult2->fetch_assoc();
            $Value['Text'] = $DbRow['Text'];
            $Value['Comment'] = $DbRow['Comment'];
            //echo('.');
          }
          $NewLine = $Value['ShortCut'].' = "'.$Value['Text'].'";';
          if($Value['Comment'] != '') $NewLine .= ' -- '.$Value['Comment'];
          $NewLine .= "\n";
          $File2->WriteLine($NewLine);
        } else $File2->WriteLine($Line."\n");
      }
      echo('Hotovo <br />');
    }
  }
}

?>
