<?php

//include_once('../includes/global.php');
include_once('../includes/zip.lib.php');
include_once('../includes/dbc.php');
include_once('export.php');    
include_once('create_addon.php');

function CreateZipFromDir(&$Zip, $Path, $ZipPath)
{
  //echo($Path.'<br />');
  $FileList = scandir($Path);
  foreach($FileList as $FileName)
  {
    if(file_exists($Path.$FileName) and ($FileName != '.') and ($FileName != '..'))
    {
      //echo($Path.$FileName.'<br />');
      if(is_dir($Path.$FileName)) CreateZipFromDir($Zip, $Path.$FileName.'/', $ZipPath.$FileName.'/');
        else $Zip->addFile(file_get_contents($Path.$FileName), $ZipPath.$FileName); 
    }          
  }
}

function OutputAoWoWToFile($ExportId)
{
  global $System, $Config;
  
  $Export = new Export($System);
  $Export->Id = $ExportId;
  $Export->Init(); 
  if(function_exists('gzcompress')) 
  {
    $SaveFilename = $Export->TempDir.'CzAoWoW_SQL.zip';
    $SQLFilename = 'CzAoWoW_SQL.sql';        
    $BufferZip = $Export->ExportToAoWoWSQL();
    $ZipFile = new zipfile();
    $ZipFile->addFile($BufferZip, $SQLFilename);
    $Buffer = $ZipFile->file();
    file_put_contents($SaveFilename, $Buffer);
  } else echo('Funkce pro tvorbu Zip souboru není podporována!');
  echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
    'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 3000)'.
    '</script>');
      
  echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
    '<a href="'.$SaveFilename.'">'.$SQLFilename.'</a><br />'.
    'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');

}

function OutputAoWoWToHTML($ExportId)
{
  global $System, $Config;
  
  $Export = new Export($System);
  $Export->Id = $ExportId;
  
  echo('Vygenerovaný SQL kód: <br /><pre class="SQLCode">');
  echo(htmlspecialchars($Export->ExportToAoWoWSQL()));
  echo('</pre>');
}

function OutputMangosSQLToFile($ExportId)
{
  global $System, $Config;
  
  $Export = new Export($System);
  $Export->Id = $ExportId;
  $Export->Init();
  if(function_exists('gzcompress')) 
  {
    $SaveFilename = $Export->TempDir.'CzWoW_SQL.zip';
    $SQLFilename = 'CzWoW_SQL.sql';        
    $BufferZip = $Export->ExportToMangosSQL();
    $ZipFile = new zipfile();
    $ZipFile->addFile($BufferZip, $SQLFilename);
    $Buffer = $ZipFile->file();
    file_put_contents($SaveFilename, $Buffer);
  } else echo('Funkce pro tvorbu Zip souboru není podporována!');
  echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
    'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 3000)'.
    '</script>');
      
  echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
    '<a href="'.$SaveFilename.'">'.$SQLFilename.'</a><br />'.
    'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');
}

function OutputMangosSQLToHTML($ExportId)
{
  global $System;
  
  $Export = new Export($System);
  $Export->Id = $ExportId;
  $Export->Init();
  echo('Vygenerovaný SQL kód: <br /><pre class="SQLCode">');
  echo(htmlspecialchars($Export->ExportToMangosSQL()));
  echo('</pre>');
}

function OutputAddon($ExportId)
{
  global $Config, $Database, $System;
  
  if(function_exists('gzcompress')) 
  {
    $Addon = new ExportAddon($System);
    $Addon->Id = $ExportId;
    $Addon->Init();
    $Addon->MakeAddon();
    
    echo('Generování addonu...<br />');
    $SaveFilename = $Config['Web']['TempFolder'].$_SESSION['User'].'/CzWoW_Addon-'.$Addon->ClientVersion['Version'].'.zip';          
    $Zip = new zipfile();
    CreateZipFromDir($Zip, $Addon->TempDir, 'CzWoW/');
    $Zip->addFile(file_get_contents('files/'.$Addon->ClientVersion['Version'].'/CzWoW/OptionsFrame.xml'), 'CzWoW/OptionsFrame.xml'); 
    $Zip->addFile(file_get_contents('files/'.$Addon->ClientVersion['Version'].'/CzWoW/CzWoW.xml'), 'CzWoW/CzWoW.xml'); 
    $Zip->addFile(file_get_contents('files/'.$Addon->ClientVersion['Version'].'/CzWoW/CzWoW.toc'), 'CzWoW/CzWoW.toc'); 
    $Zip->addFile(file_get_contents('files/'.$Addon->ClientVersion['Version'].'/CzWoW/CzWoW.lua'), 'CzWoW/CzWoW.lua'); 
    $Zip->addFile(file_get_contents('files/'.$Addon->ClientVersion['Version'].'/CzWoW/GameMenuFrame.xml'), 'CzWoW/GameMenuFrame.xml'); 
    $Zip->addFile(file_get_contents('files/'.$Addon->ClientVersion['Version'].'/CzWoW/Localization.lua'), 'CzWoW/Localization.lua'); 
    $Buffer = $Zip->file();
    file_put_contents($SaveFilename, $Buffer);
    echo('Hotovo<br /><br />');
  } else echo('Funkce pro tvorbu Zip souboru není podporována!');
  echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
    'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 3000)'.
    '</script>');
      
  echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
    '<a href="'.$SaveFilename.'">CzWoW_Addon-'.$Addon->ClientVersion['Version'].'.zip</a><br />'.
    'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');
  echo('<br /><strong>Použití ve hře</strong><br />Menu addonu ve hře vyvoláte povelem /czwow.');
}

function OutputXMLToFile($ExportId)
{
  global $Config, $System;
  
  $Export = new Export($System);
  $Export->Id = $ExportId;
  $Export->Init();
  if(function_exists('gzcompress')) 
  {
    $SaveFilename = $Export->TempDir.'CzWoW_XML.zip';
    $SQLFilename = 'CzWoW_XML.sql';        
    $BufferZip = $Export->ExportToXML();
    $ZipFile = new zipfile();
    $ZipFile->addFile($BufferZip, $SQLFilename);
    $Buffer = $ZipFile->file();
    file_put_contents($SaveFilename, $Buffer);
  } else echo('Funkce pro tvorbu Zip souboru není podporována!');
  echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
   'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 3000)'.
   '</script>');
      
  echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
    '<a href="'.$SaveFilename.'">CzWoW_SQL.zip</a><br />'.
    'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');
}

function OutputXMLToHTML($ExportId)
{
  global $System;
  
  $Export = new Export($System);
  $Export->Id = $ExportId;
  $Export->Init();
  echo('Vygenerované XML: <br /><pre class="SQLCode">');
  echo(htmlspecialchars($Export->ExportToXML()));
  echo('</pre>');
}

function OutputDBCToFile($ExportId)
{
  global $Database;
  
  echo('<form action="?Action=View&amp;Tab=6&amp;ExportId='.$ExportId.'" method="post"><input type="submit" name="Regenerate" value="Přegenerovat"/></form><br />');
  echo('U DBC souborů export textů funguje jinak, protože generování je náročné na výpočet provádí se přes noc, kdy je server nejmíň vytížen. Nyní jste zadali úlohu, která se provede v noci. Zítra si můžete stáhnout vygenerovaný soubor v sekci <a href="../download.php">Stahování</a>.<br /><br />DBC soubory je nutné zabalit do souboru patch-enGB-5.MPQ uvnitř složky "DBFilesClient" a hru spouštět přes wowme.exe. Zabalit to můžete pomocí programu <a href="../download/mpqediten32.zip">Ladik\'s MPQ Editor</a>. Stav vygenerování můžete sledovat na této stránce, kde si také můžete zítra soubor stáhnout.<br /><br />');
    
  $DbResult = $Database->SQLCommand('SELECT * FROM ExportTask WHERE Export = '.$ExportId);
  if(mysql_num_rows($DbResult) == 0)
  {
    $Database->SQLCommand('INSERT INTO ExportTask (`Export` ,`TimeStart` ) VALUES ('.$ExportId.', NOW())');
    WriteLog('Zadání úlohy pro vygenerování dbc souboru', 2);
  }  
  
  if(array_key_exists('Regenerate', $_POST))
  {
    $Database->SQLCommand('UPDATE ExportTask SET TimeStart = NOW(), TimeFinish = NULL');
    echo('Soubor zařazen znovu ke zpracování.<br/><br/>');
  }
  $DbResult = $Database->SQLCommand('SELECT * FROM ExportTask WHERE Export = '.$ExportId);
  $ExportTask = mysql_fetch_assoc($DbResult);
  if($ExportTask['TimeFinish'] > $ExportTask['TimeStart'])
  {
    echo('<strong>Soubor ke stažení: <a href="../tmp/Export/'.$ExportTask['Export'].'/CzWoW_DBC.zip">CzWoW_DBC.zip</a></strong><br/>');
  } else echo('<strong>Soubor čeká na zpracování ve frontě.</strong><br/>');
}

function OutputLua($ExportId)
{
  global $System, $Config;
  
  $Export = new Export($System);
  $Export->Id = $ExportId;
  $Export->Init();

  if(function_exists('gzcompress')) 
  {
    echo('Generování lua souborů...<br />');
    $Export->ExportToLUA();
    $SaveFilename = $Config['Web']['TempFolder'].$_SESSION['User'].'/CzWoW_Lua.zip';          
    $Zip = new zipfile();
    CreateZipFromDir($Zip, $Export->TempDir, '');
    $Buffer = $Zip->file();
    file_put_contents($SaveFilename, $Buffer);
    echo('Hotovo<br /><br />');
  } else echo('Funkce pro tvorbu Zip souboru není podporována!');
  echo('<script type="text/javascript" language="JavaScript" charset="utf-8">'.
    'setTimeout("parent.location.href=\''.$SaveFilename.'\'", 3000)'.
    '</script>');
      
  echo('Pokud nezačalo stahování, soubor by mělo jít stáhnout pomocí tohoto odkazu: '. 
    '<a href="'.$SaveFilename.'">CzWoW_Lua.zip</a><br />'.
    'Pokud se vám zdá, že filtr na export nefunguje, vymažte si vyrovnávací paměť prohlížeče a zkuste stáhnout soubor znovu.');
  echo('<br /><br /><strong>Použití ve hře</strong><br />Ze souborů vytvořte MPQ archív a nahrajte ho do hry do podsložky Data/enUS jako patch-enUS-5.MPQ. Hru spusťte pomocí programu WoWMe.exe (WoW Model Editor Fix).');
}

function ExportOutput($ExportId, $Type)
{
  if($Type == 1) OutputMangosSQLToHTML($ExportId);
  else if($Type == 2) OutputMangosSQLToFile($ExportId);
  else if($Type == 3) OutputAoWoWToHTML($ExportId);
  else if($Type == 4) OutputAoWoWToFile($ExportId);
  else if($Type == 5) OutputXMLToHTML($ExportId);
  else if($Type == 6) OutputXMLToFile($ExportId);
  else if($Type == 7) OutputAddon($ExportId);
  else if($Type == 8) OutputLua($ExportId);
  else if($Type == 9) OutputDBCToFile($ExportId);
  else echo('Nebyl vybrán žádný formát výstupu');
}

?>
